 
subroutine CalcEnergyForces(L, rc, PEnergy, Pos, Forces, N1, N2, N3, Dim)
    implicit none
    integer, intent(in) :: Dim, N1, N2, N3
    real(8), intent(in), dimension(0:Dim-1) :: L
    real(8), intent(in) :: rc
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:N1+N2+N3-1, 0:Dim-1) ::  Pos, Forces
!f2py intent(in, out, inplace) :: Pos, Forces
    real(8), parameter :: r0 = 1.
    real(8), dimension(Dim) :: rij, Posi, Fij, Posj
    real(8) :: d2, id2, id6, id12
    real(8) :: rc2, Shift
    integer :: i, j
    Forces = 0.
    PEnergy = 0.
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    do i = N1, N1 + N2 - 1
        if (Pos(i,0)-L(0)/2. > 0.) then
            Pos(i,0)=Pos(i,0)-L(0)
        end if
        if (Pos(i,0)+L(0)/2. < 0.) then
            Pos(i,0)=Pos(i,0)+L(0)
        end if
        if (Pos(i,1)-L(1)/2. > 0.) then
            Pos(i,1)=Pos(i,1)-L(1)
        end if
        if (Pos(i,1)+L(1)/2. < 0.) then
            Pos(i,1)=Pos(i,1)+L(1)
        end if
        Posi = Pos(i,:)        
        do j = i+1, N1 + N2 - 1
            if (Pos(j,0)-L(0)/2. > 0.) then
                Pos(j,0)=Pos(j,0)-L(0)
            end if
            if (Pos(j,0)+L(0)/2. < 0.) then
                Pos(j,0)=Pos(j,0)+L(0)
            end if
            if (Pos(j,1)-L(1)/2. > 0.) then
                Pos(j,1)=Pos(j,1)-L(1)
            end if
            if (Pos(j,1)+L(1)/2. < 0.) then
                Pos(j,1)=Pos(j,1)+L(1)
            end if
            Posj = Pos(j,:)
            rij = Posj - Posi
            rij(1:2) = rij(1:2) - L(0:1) * dnint(rij(1:2) / L(0:1))
            d2 = sum(rij * rij)
            if (d2 > rc2) then
                cycle
            end if
            id2 = 1. / d2            
            id6 = id2 * id2 * id2    
            id12 = id6 * id6         
            PEnergy = PEnergy + 4. * (id12 - id6) + Shift
            Fij = rij * ((-48. * id12 + 24. * id6) * id2)
            Forces(i,:) = Forces(i,:) + Fij
            Forces(j,:) = Forces(j,:) - Fij       
        enddo
    enddo
    do i = 0, N1 - 1
        if (Pos(i,0)-L(0)/2. > 0.) then
            Pos(i,0)=Pos(i,0)-L(0)
        end if
        if (Pos(i,0)+L(0)/2. < 0.) then
            Pos(i,0)=Pos(i,0)+L(0)
        end if
        if (Pos(i,1)-L(1)/2. > 0.) then
            Pos(i,1)=Pos(i,1)-L(1)
        end if
        if (Pos(i,1)+L(1)/2. < 0.) then
            Pos(i,1)=Pos(i,1)+L(1)
        end if
        Posi = Pos(i,:)
        do j = N1, N1 + N2 - 1
            if (Pos(j,0)-L(0)/2. > 0.) then
                Pos(j,0)=Pos(j,0)-L(0)
            end if
            if (Pos(j,0)+L(0)/2. < 0.) then
                Pos(j,0)=Pos(j,0)+L(0)
            end if
            if (Pos(j,1)-L(1)/2. > 0.) then
                Pos(j,1)=Pos(j,1)-L(1)
            end if
            if (Pos(j,1)+L(1)/2. < 0.) then
                Pos(j,1)=Pos(j,1)+L(1)
            end if
            Posj = Pos(j,:)
            rij = Posj - Posi
            rij(1:2) = rij(1:2) - L(0:1) * dnint(rij(1:2) / L(0:1))
            d2 = sum(rij * rij)
            if (d2 > rc2) then
                cycle
            end if
            id2 = 1. / d2            
            id6 = id2 * id2 * id2    
            id12 = id6 * id6         
            PEnergy = PEnergy + 4.*0.4* (id12 - id6) +0.4*Shift
            Fij = rij* 0.4* ((-48. * id12 + 24. * id6) * id2)
            Forces(j,:) = Forces(j,:) - Fij
        enddo
    enddo
    do i = N1 + N2, N1 + N2 + N3 - 1
        if (Pos(i,0)-L(0)/2. > 0.) then
            Pos(i,0)=Pos(i,0)-L(0)
        end if
        if (Pos(i,0)+L(0)/2. < 0.) then
            Pos(i,0)=Pos(i,0)+L(0)
        end if
        if (Pos(i,1)-L(1)/2. > 0.) then
            Pos(i,1)=Pos(i,1)-L(1)
        end if
        if (Pos(i,1)+L(1)/2. < 0.) then
            Pos(i,1)=Pos(i,1)+L(1)
        end if
        Posi = Pos(i,:)
        do j = N1, N1 + N2 - 1
            if (Pos(j,0)-L(0)/2. > 0.) then
                Pos(j,0)=Pos(j,0)-L(0)
            end if
            if (Pos(j,0)+L(0)/2. < 0.) then
                Pos(j,0)=Pos(j,0)+L(0)
            end if
            if (Pos(j,1)-L(1)/2. > 0.) then
                Pos(j,1)=Pos(j,1)-L(1)
            end if
            if (Pos(j,1)+L(1)/2. < 0.) then
                Pos(j,1)=Pos(j,1)+L(1)
            end if
            Posj = Pos(j,:)
            rij = Posj - Posi
            rij(1:2) = rij(1:2) - L(0:1) * dnint(rij(1:2) / L(0:1))
            d2 = sum(rij * rij)
            if (d2 > rc2) then
                cycle
            end if
            id2 = 1. / d2            
            id6 = id2 * id2 * id2    
            id12 = id6 * id6         
            PEnergy = PEnergy + 4.*0.4*(id12 - id6) +0.4* Shift
            Fij = rij*0.4*((-48. * id12 + 24. * id6) * id2)
            Forces(j,:) = Forces(j,:) - Fij
        enddo
    enddo
end subroutine

subroutine VVIntegrate(Pos, Vel, Accel, L, rc, dt, KEnergy, PEnergy, N1, N2, N3, Dim)
    implicit none
    integer, intent(in) :: Dim, N1, N2, N3
    real(8), intent(in) :: rc, dt
    real(8), intent(in), dimension(0:Dim-1) :: L
    real(8), intent(inout), dimension(0:N1+N2+N3-1, 0:Dim-1) :: Pos, Vel, Accel
!f2py intent(in,out,inplace) :: Pos, Vel, Accel
    real(8), intent(out) :: KEnergy, PEnergy
    external :: CalcEnergyForces
    Pos(N1 : (N1+N2)-1,:) = Pos(N1 : (N1+N2)-1, :) + dt * Vel(N1:(N1+N2)-1, :) + 0.5 * dt * dt * Accel(N1:(N1+N2)-1, :) 
    Pos(:N1-1, :) = Pos(:N1-1,: ) + dt * Vel(:N1-1,:)
    Pos((N1+N2):(N1+N2+N3)-1,:) = Pos((N1+N2):(N1+N2+N3)-1,:) + dt * Vel((N1+N2):(N1+N2+N3)-1,:)
    Vel = Vel + 0.5 * dt * Accel
    call CalcEnergyForces(L, rc, PEnergy, Pos, Accel,  N1, N2, N3, Dim)
    Vel = Vel + 0.5 * dt * Accel
    KEnergy = 0.5 * sum(Vel(N1 : (N1+N2)-1,:)*Vel(N1 : (N1+N2)-1,:))
end subroutine